#include "stdafx.h"
#include <set>
#include <ablib/textfile.h>
#include "analyze.h"
#include "TeXProject.h"

//ˑ֌WɗpĂł낤gqB
const TCHAR *Analyze::m_kaku[] = { _T("aux"),_T("toc"),_T("lot"),_T("lof"),NULL };


bool Analyze::LaTeXCheck() {
	if (m_forcelatex) {
		m_forcelatex = false;
		return true;
	}
	ablib::string file;
	static std::vector<char> buf;
	bool rv = false;
	for (std::vector<ablib::string>::size_type i = 0; i < m_files.size(); ++i) {
		for (const TCHAR **kaku = m_kaku; *kaku; ++kaku) {
			file = m_files[i].file;
			DeleteExttex(file);
			file += *kaku;
			FILE *fp = ::_tfopen(file.c_str(), _T("r"));
			std::map<ablib::string, std::vector<char> >::iterator ite = m_files[i].aux.find(*kaku);
			if (fp) {
				if (ite == m_files[i].aux.end())rv = true;
				buf.clear();
				size_t size;
				char b[4096];
				while ((size = ::fread(b, sizeof(char), 4096, fp)) > 0) {
					buf.insert(buf.end(), b, b + size);
				}
				::fclose(fp);
				if (buf != m_files[i].aux[*kaku]) {
					rv = true;
					swap(m_files[i].aux[*kaku], buf);
				}
			} else {
				if (ite != m_files[i].aux.end()) {
					m_files[i].aux.erase(ite);
					rv = true;
				}
			}
		}
	}
	return rv;
}

bool Analyze::BibTeXCheck() {
	if (m_bibtex)return false;
	bool existbibdata = false;
	ablib::TextFile tf;
	std::set<ablib::string> bibs, cits;
	for (std::vector<ablib::string>::size_type i = 0; i < m_files.size(); ++i) {
		ablib::string aux = m_files[i].file;
		DeleteExttex(aux);
		aux += _T("aux");
		if (tf.Open(aux, ablib::TextFile::read)) {
			TCHAR buf[4096];
			while (tf.ReadLine(buf, 4095)) {
				auto bibdata = ::_tcsstr(buf, _T("\\bibdata{"));
				if (!existbibdata && bibdata != nullptr)existbibdata = true;
				auto bibcite = ::_tcsstr(buf, _T("\\bibcite{"));
				if (bibcite != nullptr) {
					// ::lstrlen("\\bibcite{") = 9
					TCHAR *p = ::_tcsstr(bibcite + 9, _T("}"));
					if (p) {
						*p = '\0';
						bibs.insert(bibcite + 9);
					}
				}
				auto citation = ::_tcsstr(buf, _T("\\citation{"));
				if (citation != nullptr) {
					// ::lstrlen("\\citation{") = 10
					TCHAR *p = ::_tcsstr(citation + 10, _T("}"));
					if (p) {
						*p = '\0';
						cits.insert(citation + 10);
					}
				}
			}
			tf.Close();
		}
	}
	bool rv = existbibdata && (bibs != cits);
	if (rv) {
		m_forcelatex = true;
		m_bibtex = true;
	}
	return rv;
}


bool Analyze::MakeIndexCheck() {
	if (m_makeindex)return false;
	ablib::string f = m_files[0].file;
	DeleteExttex(f);
	f += _T("idx");
	if (ExistsFile(f.c_str())) {
		m_forcelatex = true;
		m_makeindex = true;
		return true;
	} else return false;
}

const TCHAR *Analyze::Start(const TCHAR *mainfile) {
	m_forcelatex = false; m_makeindex = false; m_bibtex = false;
	m_files.clear(); m_files.push_back(FileData(mainfile));
	TeXProject tp;
	tp.CreateFileList(mainfile);
	std::vector<TeXProject::FileData> fdata = tp.GetFileData();
	for (std::vector<TeXProject::FileData>::size_type i = 0; i < fdata.size(); ++i) {
		if (fdata[i].type == TeXProject::FileData::include)m_files.push_back(FileData(fdata[i].name));
	}
	LaTeXCheck();// .auxǂݍނ߂

	std::map<ablib::string, std::vector<char> >::iterator ite = m_files[0].aux.find(_T("aux"));
	if (ite == m_files[0].aux.end()) {
		const char r[] = "\\relax \n";
		m_files[0].aux[_T("aux")].insert(m_files[0].aux[_T("aux")].begin(), r, r + 8);
	}

	static ablib::string rv;
	rv = ablib::string(_T("latex\n")) + mainfile;
	return rv.c_str();
}

const TCHAR *Analyze::Next() {
	static ablib::string rv;
	if (LaTeXCheck())rv = _T("latex\n") + m_files[0].file;
	else if (MakeIndexCheck())rv = _T("makeindex\n") + m_files[0].file;
	else if (BibTeXCheck())rv = _T("bibtex\n") + m_files[0].file;
	else rv = _T("");
	return rv.c_str();
}

int Analyze::Finish() { return TRUE; }

void Analyze::DeleteExttex(ablib::string &f) {
	ablib::string::size_type n = f.length();
	if (n >= 4 &&
		(f[n - 1] == 'x' || f[n - 1] == 'X') &&
		(f[n - 2] == 'e' || f[n - 2] == 'E') &&
		(f[n - 3] == 't' || f[n - 3] == 'T') &&
		(f[n - 4] == '.')
		)f.erase(n - 3);
	return;
}
