#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
#include "func.h"
#include "file.h"
//#include "ForString.h"
//#include "ablib/set.h"
#include <set>

namespace{
	void split(std::vector<ablib::string> &rvalue,const TCHAR *value,const TCHAR *key){
		TCHAR *p,*q,*string = new TCHAR[::lstrlen(value) + 1],tmp;
		::lstrcpy(string,value);
		q = string;
		while(p = ::_tcsstr(q,key)){
			tmp = *p;*p = '\0';
			rvalue.push_back(q);
			*p = tmp;q = p + ::lstrlen(key);
		}
		rvalue.push_back(q);
		delete[] string;
		return;
	}
}


/*
File::File(void){
	m_findfile = INVALID_HANDLE_VALUE;
}

File::~File(void){
	for(UINT i = 0 ; i < m_fp.size() ; i++){
        if(m_fp[i])::fclose(m_fp[i]);
	}
	if(m_findfile != INVALID_HANDLE_VALUE)::FindClose(m_findfile);
}

int File::OpenFile(const TCHAR *fname,const TCHAR *mode){
	FILE *fp;
	if(::lstrcmp(fname,_T("")) == 0)return 0;
	fp = ::_tfopen(fname,mode);
	if(fp == NULL)return 0;
	for(UINT i = 0 ; i < m_fp.size() ; i++){
		if(m_fp[i] == NULL){
			m_fp[i] = fp;
			return i + 1;
		}
	}
	m_fp.push_back(fp);
	return m_fp.size();
}

TCHAR *File::ReadFileLine(int fp){
	static TCHAR str[4096];
	if(fp <= 0 || fp > static_cast<int>(m_fp.size()) || m_fp[fp - 1] == NULL)return _T("");
	if(::_fgetts(str,4095,m_fp[fp - 1]) == NULL)return _T("");
	else return str;
}

int File::Write(const TCHAR *text,int fp){
	if(fp <= 0 || fp > static_cast<int>(m_fp.size()) || m_fp[fp - 1] == NULL)return FALSE;
	if(::_ftprintf(m_fp[fp - 1],_T("%s"),text) < 0)return FALSE;
	else return TRUE;
}

int File::CloseFile(int fp){
	if(fp <= 0 || fp > static_cast<int>(m_fp.size()))return FALSE;
	if(m_fp[fp - 1]){
		if(fclose(m_fp[fp - 1]) == 0){
			m_fp[fp - 1] = NULL;
			return TRUE;
		}else return FALSE;
	}return FALSE;
}

TCHAR *File::FindFirstFile(const TCHAR *pattern){
	static WIN32_FIND_DATA wfd;
//	if(m_findfile != INVALID_HANDLE_VALUE)return _T("");
	m_findfile = ::FindFirstFile(pattern,&wfd);
	if(m_findfile == INVALID_HANDLE_VALUE)return _T("");
	else return wfd.cFileName;
}

TCHAR *File::FindNext(){
	WIN32_FIND_DATA wfd;
	if(m_findfile == INVALID_HANDLE_VALUE)return _T("");
	if(::FindNextFile(m_findfile,&wfd) == FALSE)return _T("");
	else return wfd.cFileName;
}

int File::FindClose(){
	if(::FindClose(m_findfile) == FALSE){
		return FALSE;
	}else{
		m_findfile = INVALID_HANDLE_VALUE;
		return TRUE;
	}
}
*/
int File::CompareTimeStamp(const TCHAR *fname1,const TCHAR *fname2){
	HANDLE hf1,hf2;
	FILETIME ft1,ft2;
	hf1 = CreateFile(fname1,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(hf1 == INVALID_HANDLE_VALUE)return FALSE;
	hf2 = CreateFile(fname2,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(hf2 == INVALID_HANDLE_VALUE){
		::CloseHandle(hf1);
		return FALSE;
	}
	GetFileTime(hf1,NULL,NULL,&ft1);
	GetFileTime(hf2,NULL,NULL,&ft2);
	::CloseHandle(hf1);
	::CloseHandle(hf2);
	return CompareFileTime(&ft1,&ft2);
}
/*
TCHAR *File::OpenFileDialog(HWND hwnd,const TCHAR *title,TCHAR *filter,const TCHAR *defdir){
	OPENFILENAME ofn;
	static TCHAR file[4096];
	int i,n;
	
	n = ::lstrlen(filter);
	for(i = 0 ; i < n ; i++){
		if(filter[i] == '|')filter[i] = '\0';
	}
	filter[n] = '\0';
	filter[n-1] = '\0';
	::lstrcpy(file,_T(""));
	::ZeroMemory(&ofn,sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = (HWND)hwnd;
	ofn.lpstrFilter = filter;
	ofn.lpstrTitle = title;
	ofn.lpstrFile = file;
	ofn.lpstrInitialDir = defdir;
	ofn.nMaxFile = 4095;
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;

	if(GetOpenFileName(&ofn) == FALSE)return _T("");
	else return file;
}

TCHAR *File::OpenDirDialog(HWND hwnd,const TCHAR *title,const TCHAR *defdir){
	BROWSEINFO bi;
	::ZeroMemory(&bi,sizeof(BROWSEINFO));

	static TCHAR rv[4096];
	::lstrcpy(rv,_T(""));

	bi.hwndOwner = hwnd;
	bi.pszDisplayName = rv;
	bi.lpszTitle = title;
	bi.ulFlags = BIF_RETURNONLYFSDIRS;
	bi.lpfn = OpenDirCallBack;
	bi.lParam = reinterpret_cast<LPARAM>(defdir);

	LPITEMIDLIST retlist;
	retlist = SHBrowseForFolder(&bi);
	if(retlist){
		if(SHGetPathFromIDList(retlist,rv)){
			CoTaskMemFree(retlist);
			return rv;
		}
		return _T("");
	}else return _T("");
}

int File::OpenDirCallBack(HWND hwnd,UINT uMsg,LPARAM lParam,LPARAM data){
	switch(uMsg){
	case BFFM_INITIALIZED:
		::SendMessage(hwnd,BFFM_SETSELECTION,TRUE,data);
		return 0;
	default:
		return 0;
	}
}

*/
int File::DiffFile(const TCHAR *filename1,const TCHAR *filename2){
	FILE *fp1,*fp2;
	TCHAR *rv1,*rv2;
	TCHAR tmp1[1024],tmp2[1024];
	int rv = FALSE;
	fp1 = ::_tfopen(filename1,_T("r"));
	if(fp1 == NULL)return -1;
	fp2 = ::_tfopen(filename2,_T("r"));
	if(fp2 == NULL){
		fclose(fp1);
		return -1;
	}
	while(true){
		rv1 = ::_fgetts(tmp1,1023,fp1);
		rv2 = ::_fgetts(tmp2,1023,fp2);
		if((rv1 == NULL && rv2 != NULL) || (rv1 != NULL && rv2 == NULL)){
			rv = FALSE;
			break;
		}
		if(rv1 == NULL && rv2 == NULL){
			rv = TRUE;
			break;
		}
		if(::lstrcmp(tmp1,tmp2) != 0){
			rv = FALSE;
			break;
		}
	}
	::fclose(fp1);
	::fclose(fp2);
	return rv;
}

int File::CheckSameFile(const TCHAR *filename1, const TCHAR *filename2) {
	ablib::string f1, f2;
	if (::lstrcmp(filename1, _T("")) == 0 || ::lstrcmp(filename2, _T("")) == 0)return FALSE;
	f1 = TransRegularPath(filename1);
	f2 = TransRegularPath(filename2);
	f1.tolower();
	f2.tolower();
	return (f1 == f2);
}

const TCHAR *File::TransRegularPath(const TCHAR *fn) {
	static ablib::string rv;
	std::vector<ablib::string> sa, sa2;
	UINT i;
	int len = 0;
	split(sa, const_cast<TCHAR *>(fn), _T("\\"));
	for (i = 0; i < sa.size(); ++i) {
		if (sa[i] == _T("."))continue;
		else if (sa[i] == _T("..")) { if (!sa2.empty())sa2.pop_back(); } else if (sa[i] == _T(""))continue;
		else sa2.push_back(sa[i]);
	}
	rv = _T("");
	for (i = 0; i < sa2.size(); ++i) {
		if (i != 0)rv += _T("\\");
		rv += sa2[i];
	}
	return rv.c_str();
}
/*
int File::SortFile(const TCHAR *fname){
	FILE *fp;
	std::set<ablib::string> sa;
	TCHAR str[4096];
	fp = ::_tfopen(fname,_T("r"));
	if(!fp)return FALSE;
	while(::_fgetts(str,4096,fp))sa.insert(str);
	::fclose(fp);
	fp = ::_tfopen(fname,_T("w"));
	if(!fp)return FALSE;
	for(std::set<ablib::string>::iterator i = sa.begin() ; i != sa.end() ; i++)::_ftprintf(fp,_T("%s"),i->c_str());
	::fclose(fp);
	return TRUE;
}

DWORD File::GetFilesize(const TCHAR *fname){
	HANDLE h;
	DWORD rv;
	h = CreateFile(fname,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	rv = ::GetFileSize(h,NULL);
	::CloseHandle(h);
	return rv;
}
*/

bool File::ExistsFile(const TCHAR *filename){
	return (::GetFileAttributes(filename) != static_cast<DWORD>(-1));
}
/*
const TCHAR *File::Which(const TCHAR *cmd){
	static ablib::string rv;
	if(::IsBadStringPtr(cmd,1) != FALSE)return _T("");
	std::vector<ablib::string> envpath;
	ablib::string path;
	TCHAR env[4096];
	UINT i;
	::GetEnvironmentVariable(_T("PATH"),env,4096);
	String::split(envpath,env,_T(";"));
	for(i = 0 ; i < envpath.size() ; i++){
		if(envpath[i][envpath[i].length()-1] != '\\')envpath[i] += _T("\\");
		path = envpath[i];
		path += cmd;
		path += _T(".exe");
		if(::GetFileAttributes(path.c_str()) != -1){
			rv = envpath[i];
			return rv.c_str();
		}
	}
	rv = _T("");
	return rv.c_str();
}

int File::DeleteFiles(const TCHAR *file){
	if(::lstrcmp(file,_T("")) == 0)return TRUE;
	WIN32_FIND_DATA wfd;
	HANDLE hFind;
	DWORD fatt = ::GetFileAttributes(file);
	if(fatt == static_cast<DWORD>(-1))return TRUE;
	if(!(fatt & FILE_ATTRIBUTE_DIRECTORY))return ::DeleteFile(file);
	ablib::string pattern = file;
	ablib::string dir = file;
	if(dir[dir.length() - 1] != '\\')dir += _T("\\");
	ablib::string d = file;
	pattern += _T("*.*");
	hFind = ::FindFirstFile(pattern.c_str(),&wfd);
	do{
		if(::lstrcmp(wfd.cFileName,_T(".")) == 0 || ::lstrcmp(wfd.cFileName,_T("..")) == 0)continue;
		d = dir;
		d += wfd.cFileName;
		if(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
			d += _T("\\");
			File::DeleteFiles(d.c_str());
		}else ::DeleteFile(d.c_str());
	}while(::FindNextFile(hFind,&wfd));

	::FindClose(hFind);
	d = dir;
	d.erase(d.length() - 1);
	::RemoveDirectory(d.c_str());
	return TRUE;
}

int File::CreateDir(const TCHAR *dir){
	TCHAR *q = TransRegularPath(dir);
	::lstrcpy(q,dir);
	if(dir[::lstrlen(dir) - 1] != '\\')::lstrcat(q,_T("\\"));
#ifdef UNICODE
	for(TCHAR *p = q ; *p ; p++){
#else
	for(TCHAR *p = q ; *p ; p += (IsKanji(*p) ? 2 : 1)){
#endif
		if(*p == '\\'){
			*p = '\0';
			if(!ExistsFile(q) && !::CreateDirectory(q,NULL)){
				delete[] q;
				return FALSE;
			}
			*p = '\\';
		}
	}
	delete[] q;
	return TRUE;
}
*/