#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <system/Process.h>
#include <boost/filesystem.hpp>
#include <regex>
#include "Analyze.h"
#include "func.h"
#include "file.h"
#include "TeXProject.h"

HANDLE g_HStdIn,g_HStdOut,g_HStdError;
#define VERSIONSTR _T("0.18")
const TCHAR msg[] = _T("This is LaTeXCompile Version ") VERSIONSTR _T("\n");
const TCHAR version[] =
	_T("LaTeXCompile version ") VERSIONSTR _T("\n")
	_T("Copyright (C) 2002 - 2016 Abe Noriyuki\n");

int g_recompilenum;
ablib::string g_latex,g_bibtex,g_makeindex;
bool g_guess = true;
bool g_guessparent = true;

void Error(TCHAR *message){
	DWORD dwSize;
	::WriteFile(g_HStdOut,message,::lstrlen(message),&dwSize,NULL);
}

int Help(){
	DWORD dwSize;
	const TCHAR helpmsg[] = 
#ifdef JA
		_T("g : latexcompile [IvV] t@C\n")
		_T("\n")
		_T("IvV:\n")
		_T("--latex          : LaTeX̂߂̃vOw肷D\n")
		_T("--bibtex         : BibTeX̂߂̃vOw肷D\n")
		_T("--makeindex      : MakeIndex̂߂̃vOw肷D\n")
		_T("--num            : RpC񐔂̍őlw肷D\n")
		_T("--noguess        : LaTeXR}h̎ŝ݂sD\n")
		_T("--noguessparent  : et@C̐sȂD\n") 
		_T("-h               : ̃bZ[W̕\D\n")
		_T("-v               : o[W\D\n")
		_T("\n")
		_T(":\n")
		_T("latexcompile --latex \"latex -synctex=1 %b%k\" foo.tex\n");
#else
		_T("Usage: latexcompile [Option] filename\n")
		_T("\n")
		_T("Options:\n")
		_T("--latex          : Specify the program for LaTeX\n")
		_T("--bibtex         : Specify the program for BibTeX\n")
		_T("--makeindex      : Specify the program for MakeIndex\n")
		_T("--num            : Specify the maximum number of times to compile\n")
		_T("--noguess        : Do not guess (only exec a latex command)\n")
		_T("--noguessparent  : Do not guess a parent file\n")
		_T("-h               : Show this message\n")
		_T("-v               : Show the version\n")
		_T("\n")
		_T("Example:\n")
		_T("latexcompile --latex \"latex -synctex=1 %b%k\" foo.tex\n");
#endif
	::WriteFile(g_HStdOut,helpmsg,::lstrlen(helpmsg),&dwSize,NULL);
	return -1;
}

int Version(){
	DWORD dwSize;
	::WriteFile(g_HStdOut,version,::lstrlen(version),&dwSize,NULL);
	return -2;
}


ablib::string GetMyFileName(){
	TCHAR *rv;
	int mem = 1024;
	DWORD a;
	//g(latexcompile.exe)̃t@C擾
	rv = new TCHAR[mem + 1];
	if(rv == NULL)return _T("");
	while(TRUE){
		a = GetModuleFileName(NULL,rv,mem);
		if(a == 0){
			delete[] rv;
			return _T("");
		}
		if(a < mem)break;
		mem = mem * 2;
		delete[] rv;
		rv = new TCHAR[mem + 1];
		if(rv== NULL)return _T("");
	}
	ablib::string rstr = rv;
	delete[] rv;
	return rstr;
}

//ψgȂccƎłvD
ablib::string TransLikeSprintf(ablib::string *str,...){
	std::vector<ablib::string> sa;
	std::vector<TCHAR> syosiki;
	va_list args;
	va_start(args,str);
	TCHAR tmpchar,*tmpstr;
	while(true){
		tmpchar = va_arg(args,TCHAR);
		if(tmpchar == 0)break;
		syosiki.push_back(tmpchar);
		tmpstr = va_arg(args,PTCHAR);
		if(::IsBadStringPtr(tmpstr,1) != FALSE){
			va_end(args);
			return _T("");
		}
		sa.push_back(tmpstr);
	}
	va_end(args);
	ablib::string rv = _T("");
	int i = 0;
	int j = 0;
	bool parcent = false;
	for(i = 0 ; i < str->length() ; i++){
#ifndef UNICODE
		if(IsKanji((*str)[i]))i++;
		else if((*str)[i] == '%'){
#else
		if((*str)[i] == '%'){
#endif
			i++;
			if((*str)[i] == '%'){
				rv += str->substr(j,i - j - 1);
				j = i + 1;
				continue;
			}
			parcent = false;
			for(UINT k = 0 ; k < sa.size() ; k++){
				if((*str)[i] == syosiki[k]){
					rv += str->substr(j,i - j - 1);
					rv += sa[k];
					j = i + 1;
					parcent = true;
					break;
				}
			}
			if(parcent)continue;
		}
	}
	rv += str->substr(j,i-j);
	return rv;
}


int ExecCommand(const ablib::string &command,const ablib::string &dir){
	DWORD Size;
#ifdef JA
	::WriteFile(g_HStdOut,_T("\n\nJgfBNg : "),25,&Size,NULL);
#else
	::WriteFile(g_HStdOut,_T("\n\nCurrent Directory : "),22,&Size,NULL);
#endif
	::WriteFile(g_HStdOut,dir.c_str(),dir.length(),&Size,NULL);
#ifdef JA
	::WriteFile(g_HStdOut,_T("\nR}h : "),12,&Size,NULL);
#else
	::WriteFile(g_HStdOut,_T("\nCommand : "),11,&Size,NULL);
#endif
	::WriteFile(g_HStdOut,command.c_str(),command.length(),&Size,NULL);
	::WriteFile(g_HStdOut,_T("\n///////////////////////////////////////////\n"),45,&Size,NULL);
	::WriteFile(g_HStdOut,_T("\n"),1,&Size,NULL);
	SECURITY_ATTRIBUTES sa;
	ZeroMemory(&sa,sizeof(SECURITY_ATTRIBUTES));
	sa.nLength = sizeof(SECURITY_ATTRIBUTES);
	sa.bInheritHandle = TRUE;
	sa.lpSecurityDescriptor = NULL;
	STARTUPINFO si;
	ZeroMemory(&si,sizeof(STARTUPINFO));
	si.cb = sizeof(STARTUPINFO);
	si.dwFlags = STARTF_USESTDHANDLES | STARTF_USESHOWWINDOW;
	si.wShowWindow = SW_SHOW;
	si.hStdError = g_HStdError;
	si.hStdInput = g_HStdIn;
	si.hStdOutput = g_HStdOut;
	PROCESS_INFORMATION pi;
	if(!::CreateProcess(NULL,const_cast<TCHAR *>(command.c_str()),&sa,&sa,TRUE,0,NULL,dir.c_str(),&si,&pi)){
#ifdef JA
		::WriteFile(g_HStdOut,command.c_str(),command.length(),&Size,NULL);
		::WriteFile(g_HStdOut,_T("̎sɎsI\n\n"),16,&Size,NULL);
#else
		::WriteFile(g_HStdOut,"Exec ",5,&Size,NULL);
		::WriteFile(g_HStdOut,command.c_str(),command.length(),&Size,NULL);
		::WriteFile(g_HStdOut," Failed!\n\n",9,&Size,NULL);
#endif
		return -4;
	}
	::WaitForSingleObject(pi.hThread,INFINITE);
	DWORD rv;
	::GetExitCodeProcess(pi.hProcess,&rv);
	::CloseHandle(pi.hProcess);
	::CloseHandle(pi.hThread);
	return rv;
}

//AnalyzeԂ镶ƂɎs
int Exec(const ablib::string &cmd){
	int i = 0;
	ablib::string com = cmd.substr(0,cmd.find(_T("\n")));
	if(com == _T("latex"))com = g_latex;
	else if(com == _T("bibtex"))com = g_bibtex;
	else if(com == _T("makeindex"))com = g_makeindex;
	else return -4;
	DEBUGSTRING(_T("Exec: latex-%s,makeindex-%s,bibtex-%s"),g_latex.c_str(),g_makeindex.c_str(),g_bibtex.c_str());
	DEBUGSTRING(_T("Exec: com=%s"),com.c_str());
	boost::filesystem::path path(cmd.substr(cmd.find(_T("\n")) + 1));
#ifdef UNICODE
	ablib::string dir = path.parent_path().wstring();
	ablib::string fname = path.filename().wstring();
#else
	ablib::string dir = path.parent_path().string();
	ablib::string fname = path.filename().string();
#endif
	TCHAR str[4096];
	if(dir == _T("")){
		::GetCurrentDirectory(4095,str);
		dir = str;dir += _T("\\");
	}
	ablib::string kaku;
	if(fname.rfind(_T(".")) != ablib::string::npos){
		kaku = fname.substr(fname.rfind(_T(".")));
		fname.erase(fname.rfind(_T(".")));
	}
	ablib::string command = TransLikeSprintf(&com,'b',fname.c_str(),'f',path.c_str(),'d',dir.c_str(),'k',kaku.c_str(),0);

	DEBUGSTRING(_T("R}h %s JgfBNg %s Ŏs"),command.c_str(),dir.c_str());

	return ExecCommand(command,dir);
}


int Compile(ablib::string &input){
	Analyze ana;
	DWORD Size;
	int exitcode;
	bool noanalyze = false;
	ablib::string path = input;
	if(path.length() < 2 || path[1] != ':'){
		// tpXł͂Ȃ
		TCHAR buf[4096];
		::GetCurrentDirectory(4095, buf);
		path = ablib::string(buf) + _T("\\") + path;
	}
	if(!File::ExistsFile(path.c_str()))path += _T(".tex");
	if(g_guessparent) {
		path = TeXProject().FindParentFile(path.c_str());
		if(path == _T("")) {
#ifdef JA
			auto msg = _T("et@C̐ɎsC") + input + _T("g܂");
#else
			auto msg = _T("failed to guess parent file, I will use ") + input;
#endif
			::WriteFile(g_HStdOut, msg.c_str(), msg.length(), &Size, NULL);
		}
		DEBUGSTRING(_T("et@CF%s"), path.c_str());
	}
	if(path == _T(""))path = input;
	boost::filesystem::path p(path.c_str());
	TCHAR str[4096], message[256];
	auto dir = p.parent_path().string();
	auto fname = p.filename().string();
	if(dir == _T("")){
		::GetCurrentDirectory(4096, str);
		dir = str;
		dir += _T("\\");
		path = dir + path;
	} else dir += _T("\\");

	DEBUGSTRING(_T("Analyze classɓnpX : \"%s\""), path.c_str());

	ablib::string command = ana.Start(path.c_str());

	DEBUGSTRING(_T("Analyze class̕ԂR}hF\"%s\""), command.c_str());

	if(command == _T("")){
		command = _T("latex\n");
		command += dir + fname;
		noanalyze = false;
	}

	::WriteFile(g_HStdOut, _T("\n///////////////////////////////////////////\n"), 45, &Size, NULL);
#ifdef JA
	::WriteFile(g_HStdOut, _T("1ڂ̎s"), 11, &Size, NULL);
#else
	::WriteFile(g_HStdOut, _T("Run 1st Command"), 15, &Size, NULL);
#endif
	exitcode = Exec(command);
	if(noanalyze)return exitcode;
	if(exitcode == 0){
		for(int i = 1; ; i++){
			command = ana.Next();
			if(command == _T(""))break;
			if(i == g_recompilenum) {
				ana.Finish();
				return -5;
			}
#ifdef JA
			::wsprintf(message, _T("%dڂ̎s"), i + 1);
#else
			if(i % 100 == 10)::wsprintf(message, _T("Run %dth Command"), i + 1);
			else if(i % 100 == 11)::wsprintf(message, _T("Run %dth Command"), i + 1);
			else if(i % 100 == 12)::wsprintf(message, _T("Run %dth Command"), i + 1);
			else if(i % 10 == 0)::wsprintf(message, _T("Run %dst Command"), i + 1);
			else if(i % 10 == 1)::wsprintf(message, _T("Run %dnd Command"), i + 1);
			else if(i % 10 == 2)::wsprintf(message, _T("Run %drd Command"), i + 1);
			else                  ::wsprintf(message, _T("Run %dth Command"), i + 1);
#endif
			::WriteFile(g_HStdOut, _T("\n///////////////////////////////////////////\n"), 45, &Size, NULL);
			::WriteFile(g_HStdOut, message, ::lstrlen(message), &Size, NULL);
			exitcode = Exec(command);
			if(exitcode != 0)break;
		}
	}
	ana.Finish();
	return exitcode;
}

ablib::string getinistr(const TCHAR *sec, const TCHAR *key, const TCHAR *inipath){
	TCHAR *rvalue = NULL;
	int n = 1024;
	rvalue = new TCHAR[n];
	while((signed int)::GetPrivateProfileString(sec, key, _T(""), rvalue, n - 1, inipath) == n - 1){
		n = 2 * n;
		delete[] rvalue;
		rvalue = new TCHAR[n];
	}
	ablib::string rv = rvalue;
	delete[] rvalue;
	return rv;
}

int getininum(const TCHAR *sec, const TCHAR *key, const TCHAR *inipath){
	return ::GetPrivateProfileInt(sec, key, 0, inipath);
}

std::string AddOptions(const std::string &original, const std::vector<ablib::string> &options){
	if(options.empty())return original;
	std::regex reg(_T("^([^ ]*(\"[^\"]*\")*)* "));
	std::smatch match;
	ablib::string path, opt;
	if(std::regex_search(original, match, reg)){
		path = match.str();
		path.erase(path.length() - 1);
		opt = original.substr(match.length(0));
	} else {
		path = original;
	}
	for each (auto &&o in options)	path += _T(" ") + o;
	if(opt != _T(""))path += _T(" ") + opt;
	return path;
}

//IvV擾
int GetOpt(int argc, TCHAR *argv[], std::vector<ablib::string> &sa) {
	ablib::string myname = GetMyFileName();
	FILE *fp;
#ifdef JA
	TCHAR *optendmsg = _T("IvV̈܂B\n");
#else
	TCHAR *optendmsg = _T("No argument for an option\n");
#endif
	if (myname == _T(""))return 3;
	myname.erase(myname.length() - 3);
	myname += _T("ini");
	if (File::ExistsFile(myname.c_str()) == false) {
		fp = ::_tfopen(myname.c_str(), _T("w"));
		if (fp) {
			ablib::string str =
				_T("[latex]\n")
				_T("Command=platex %b%k\n")
				_T("[bibtex]\n")
				_T("Command=pbibtex %b\n")
				_T("[makeindex]\n")
				_T("Command=mendex %b\n")
				_T("[ReCompile]\n")
				_T("Num=5\n");
			::_ftprintf(fp, _T("%s"), str.c_str());
			::fclose(fp);
		} else {
#ifdef JA
			Error(_T("ݒt@C̍쐬Ɏs܂D"));
#else
			Error(_T("Failed to create a file for setting."));
#endif
			return -100;
		}
	}
	g_recompilenum = getininum(_T("ReCompile"), _T("Num"), myname.c_str());
	g_latex = getinistr(_T("latex"), _T("Command"), myname.c_str());
	g_bibtex = getinistr(_T("bibtex"), _T("Command"), myname.c_str());
	g_makeindex = getinistr(_T("makeindex"), _T("Command"), myname.c_str());
	std::vector<ablib::string> unknownoptions;
	for (int i = 1; i < argc; i++) {
		DEBUGSTRING(_T("%dԖڂ̈F%s"), i, argv[i]);
		if (::lstrcmpn(argv[i], _T("--"), 2) == 0) {
			if (::lstrcmp(argv[i], _T("--latex")) == 0) {
				++i;
				if (i == argc) {
					Error(optendmsg);
					return -3;
				} else g_latex = argv[i];
			} else if (::lstrcmp(argv[i], _T("--bibtex")) == 0) {
				++i;
				if (i == argc) {
					Error(optendmsg);
					return -3;
				} else g_bibtex = argv[i];
			} else if (::lstrcmp(argv[i], _T("--makeindex")) == 0) {
				++i;
				if (i == argc) {
					Error(optendmsg);
					return -3;
				} else g_makeindex = argv[i];
			} else if (::lstrcmp(argv[i], _T("--num")) == 0) {
				++i;
				if (i == argc) {
					Error(optendmsg);
					return -3;
				} else g_recompilenum = ::_tstoi(argv[i]);
			} else if (::lstrcmp(argv[i], _T("--noguess")) == 0) {
				g_guess = false;
			} else if (::lstrcmp(argv[i], _T("--noguessparent")) == 0) {
				g_guessparent = false;
			} else {
				unknownoptions.push_back(argv[i]);
			}
		} else if (argv[i][0] == '-') {
			if (argv[i][1] == 'h')return Help();
			else if (argv[i][1] == 'v')return Version();
			else unknownoptions.push_back(argv[i]);
		} else sa.push_back(argv[i]);
	}
	g_latex = AddOptions(g_latex, unknownoptions);
	return 0;
}

//C[`
int main(int argc, TCHAR* argv[]){
	int rv;
	DWORD dwSize;
	std::vector<ablib::string> sa;
	//	if(PrepareConsole() == false)return 2;
	g_HStdIn = ::GetStdHandle(STD_INPUT_HANDLE);
	g_HStdOut = ::GetStdHandle(STD_OUTPUT_HANDLE);
	g_HStdError = ::GetStdHandle(STD_ERROR_HANDLE);
	if(g_HStdOut == INVALID_HANDLE_VALUE)return 1;
	rv = GetOpt(argc, argv, sa);
	if(rv != 0)return rv;
	DEBUGSTRING(_T("main: latex-%s,makeindex-%s,bibtex-%s"), g_latex.c_str(), g_makeindex.c_str(), g_bibtex.c_str());
#ifdef JA
	if(sa.size() == 0)::WriteFile(g_HStdOut, _T("\nLaTeXCompile : ̓t@C܂B\n"), 44, &dwSize, NULL);
#else
	if(sa.size() == 0)::WriteFile(g_HStdOut, _T("\nLaTeXCompile : No Input File\n"), 30, &dwSize, NULL);
#endif
	else ::WriteFile(g_HStdOut, msg, ::lstrlen(msg), &dwSize, NULL);
	if(g_guess){
		for(UINT i = 0; i < sa.size(); ++i){
			rv = Compile(sa[i]);
			if(rv != 0)break;
		}
	} else{
		for(UINT i = 0; i < sa.size(); ++i){
			DWORD Size;
			ablib::string path = g_guessparent ? TeXProject().FindParentFile(sa[i].c_str()) : sa[i];
			::WriteFile(g_HStdOut, _T("\n///////////////////////////////////////////"), 45, &Size, NULL);
			ablib::string cmd = _T("latex\n") + path;
			rv = Exec(cmd);
		}
	}
	//	::FreeConsole();
	return rv;
}

